<?php
// +--------------------------------------------------------------------------+
// | glFusion CMS                                                             |
// +--------------------------------------------------------------------------+
// | filecheck_data.php                                                       |
// |                                                                          |
// | All valid glFusion directories / files                                   |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2008-2014 by the following authors:                        |
// |                                                                          |
// | Mark R. Evans          mark AT glfusion DOT org                          |
// | Mark Howard            mark AT usable-web DOT com                        |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | This program is free software; you can redistribute it and/or            |
// | modify it under the terms of the GNU General Public License              |
// | as published by the Free Software Foundation; either version 2           |
// | of the License, or (at your option) any later version.                   |
// |                                                                          |
// | This program is distributed in the hope that it will be useful,          |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with this program; if not, write to the Free Software Foundation,  |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.          |
// |                                                                          |
// +--------------------------------------------------------------------------+

// updated 2009/02/11

if (!defined ('GVERSION')) {
    die ('This file can not be used on its own.');
}

// these file/dir names will be completely ignored, and not checked

$glfIgnore = array('.','..','.svn','.git','CVS','cgi-bin','.htaccess','robots.txt','lightash');

// these are the bundled plugins.  they are fully defined/checked as below

$glfPlugins = array(
    'bad_behavior2',
    'calendar',
    'captcha',
    'ckeditor',
    'commentfeeds',
    'filemgmt',
    'forum',
    'links',
    'mediagallery',
    'polls',
    'spamx',
    'staticpages'
);

// glFusion Distribution Directories (as-shipped)

// test: 'R'= must exist, and recurse, 'E'= must exist, but do not recurse
//       'I'= if exists, ignore
// preq:'R' = readable, 'W' = writeable

$glfDir = array(
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/backups'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/data'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/data/layout_cache'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/data/temp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/language'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/bbcode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/email-address-validation'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/feedcreator'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/geshi'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/getid3'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/html2text'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmLawed'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/Email'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Builder'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Interchange'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Decorator'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/CSS'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/HTML'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/URI'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/EntityLookup'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Filter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/classes'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/messages'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Lexer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Node'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/TagTransform'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/VarParser'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/http'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/oauth'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/phpmailer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Content'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Content/Type'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Decode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Decode/HTML'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/HTTP'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Net'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Parse'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/XML'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/XML/Declaration'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/docs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/examples'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/exp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/mbstring'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/native'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/lib/utf8/utils'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'private/logs'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'private/plugins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/weekview'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/weekview/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/class'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/fonts'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/ckeditor'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/css'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/include'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/js'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/reports'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/reports/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/userprefs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/userprefs/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/links/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/docs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/simpleviewer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/simpleviewer/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/tmp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/uploads'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/spamx/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/sql'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/sql/updates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/autotags'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/classes'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/classes/authentication'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/classes/authentication/ldap'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/classes/openid'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/databases'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/imglib'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Archive'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Auth'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Console'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer/Exception'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Exception'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider/Exception'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/HMAC'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/RSA'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Store'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Store/Consumer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Adapter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Observer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Net'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/OS'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/ChannelFile'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Downloader'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Frontend'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Generator'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Parser'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/v2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/REST'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Postinstallscript'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Replace'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Unixeol'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Windowseol'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Validator'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/scripts'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Services'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Structures'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph/Manipulator'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/XML'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'private/system/pear/XML/RPC'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/install'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/install/include'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/install/language'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/install/layout'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/install/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/bad_behavior2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/calendar'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/captcha'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/ckeditor'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/commentfeeds'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/filemgmt'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/links'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/4images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Coppermine'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Gallery1'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/gallery2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/geekary'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/gl_story'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Inmemoriam'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/polls'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/admin/plugins/staticpages'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/backend'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/bad_behavior2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/calendar'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/calendar/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/captcha'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/captcha/class'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/adapters'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about/dialogs/hidpi'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/clipboard'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/clipboard/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/colordialog'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/colordialog/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/dialog'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/div'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/div/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/fakeobjects'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/fakeobjects/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/masks'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/media'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Font'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/vendor'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/vendor/de77'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/comment'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/dialog'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/display'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/merge'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/merge/dep'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/mode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/runmode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/scroll'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/search'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/selection'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/tern'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/wrap'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/keymap'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/lib'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/javascript'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.splitter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/styles'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/userfiles'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/utils'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/find'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/find/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/flash'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/flash/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/flash/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/iframe'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/iframe/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/iframe/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/image'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/image/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/image/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/images/hidpi'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/liststyle'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/liststyle/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/magicline'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/magicline/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/magicline/images/hidpi'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/css'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/jscripts'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/langs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pagebreak'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pagebreak/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pastefromword'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pastefromword/filter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/placeholder'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/placeholder/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/preview'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showprotected'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showprotected/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showprotected/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/table'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/table/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/tabletools'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/tabletools/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/widget'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/widget/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2/lang'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/hidpi'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/filemgmt'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/filemgmt/images'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/filemgmt_data'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/category_snaps'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/category_snaps/tmp'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/files'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/files/tmp'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/snaps'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/filemgmt_data/snaps/tmp'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images/badges'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images/icons'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images/moods'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/forum/javascript'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/forum/media'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/forum/media/tn'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/help'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/images'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/articles'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/images/library'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/images/library/_thumbs'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/library/File'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/library/Flash'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/library/Image'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/library/Media'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/library/userfiles'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/images/menu'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/images/topics'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/images/translations'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/images/userphotos'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/javascript'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/javascript/mootools'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/autotag'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/common'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/common/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/logo'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/mail'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/mail/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/story'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/story/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/topic'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/topic/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/bbcode'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/bbcode/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/custom'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/moosimplebox'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/js'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/custom'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/custom'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/links'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/links/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbook'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/js'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/covers'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/0'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/1'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/2'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/3'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/4'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/5'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/6'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/7'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/8'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/9'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/a'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/b'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/c'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/d'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/e'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/disp/f'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/0'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/1'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/2'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/3'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/4'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/5'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/6'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/7'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/8'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/9'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/a'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/b'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/c'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/d'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/e'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/orig/f'),
    array( 'test' => 'R', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/0'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/1'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/2'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/3'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/4'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/5'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/6'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/7'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/8'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/9'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/a'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/b'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/c'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/d'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/e'),
    array( 'test' => 'E', 'preq' => 'W', 'path' => 'public_html/mediagallery/mediaobjects/tn/f'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/mediagallery/players'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/watermarks'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/polls'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/polls/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/staticpages'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/staticpages/images'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/webservices'),
    array( 'test' => 'R', 'preq' => 'R', 'path' => 'public_html/webservices/atom')

);

// test: 'E'=must exist
// preq: 'R' = readable, 'W' = writeable

$glfFile = array(
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/db-config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-custom.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/siteconfig.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/stylecache_nouveau.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/jscache_nouveau.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/backups/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/backups/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/data/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/data/layout_cache/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/data/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/data/temp/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/db-config.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/emailglfusionstories'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/filecheck_data.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/INSTALL'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/afrikaans.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/afrikaans_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/bosnian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/bosnian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/bulgarian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/bulgarian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/catalan.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/catalan_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/croatian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/croatian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/danish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/farsi_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/finnish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/french_france.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/french_france_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/hellenic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/hellenic_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/indonesian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/indonesian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/italian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/italian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/korean.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/korean_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/norwegian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/norwegian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/polish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/polish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/portuguese.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/portuguese_brazil.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/portuguese_brazil_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/portuguese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/romanian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/romanian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/russian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/russian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/slovak.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/slovak_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/spanish_argentina.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/spanish_argentina_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/swedish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/swedish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/turkish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/turkish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/bbcode/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/bbcode/stringparser.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/bbcode/stringparser_bbcode.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/email-address-validation/EmailAddressValidator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/email-address-validation/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/feedcreator/feedcreator.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/feedcreator/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/abap.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/actionscript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/actionscript3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/ada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/apache.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/applescript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/apt_sources.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/asm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/asp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/autoit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/bash.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/basic4gl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/blitzbasic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/bnf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/boo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/c.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/caddcl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cadlisp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cfdg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cfm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cil.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cobol.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cpp-qt.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/cpp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/csharp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/css-gen.cfg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/css.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/c_mac.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/d.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/delphi.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/diff.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/div.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/dos.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/dot.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/eiffel.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/fortran.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/freebasic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/genero.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/gettext.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/glsl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/gml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/gnuplot.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/groovy.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/haskell.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/html4strict.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/idl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/ini.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/inno.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/io.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/java.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/java5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/javascript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/kixtart.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/klonec.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/klonecpp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/latex.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/lisp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/lotusformulas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/lotusscript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/lua.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/m68k.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/matlab.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/mirc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/mpasm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/mxml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/mysql.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/nsis.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/objc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/ocaml-brief.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/ocaml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/oobas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/oracle8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/pascal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/per.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/perl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/php-brief.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/php.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/pic16.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/plsql.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/povray.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/powershell.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/progress.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/python.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/qbasic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/rails.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/reg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/robots.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/ruby.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/sas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/scala.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/scheme.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/sdlbasic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/smalltalk.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/smarty.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/sql.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/tcl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/thinbasic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/tsql.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/typoscript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/vb.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/vbnet.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/verilog.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/vhdl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/visualfoxpro.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/winbatch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/xml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/xorg_conf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/xpp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi/z80.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/geshi.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/geshi/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/changelog.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/dependencies.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/extension.cache.dbm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/extension.cache.mysql.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/extension.cache.sqlite3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/getid3.lib.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/getid3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/license.commercial.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/license.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.archive.gzip.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.archive.rar.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.archive.szip.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.archive.tar.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.archive.zip.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.asf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.bink.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.flv.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.matroska.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.mpeg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.nsv.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.quicktime.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.real.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.riff.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.swf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio-video.ts.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.aa.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.aac.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.ac3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.au.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.avr.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.bonk.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.dss.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.dts.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.flac.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.la.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.lpac.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.midi.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.mod.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.monkey.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.mp3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.mpc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.ogg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.optimfrog.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.rkau.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.shorten.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.tta.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.voc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.vqf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.audio.wavpack.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.bmp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.efax.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.gif.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.jpg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.pcd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.png.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.svg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.graphic.tiff.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.cue.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.doc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.exe.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.iso.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.msoffice.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.par2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.misc.pdf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.tag.apetag.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.tag.id3v1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.tag.id3v2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.tag.lyrics3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/module.tag.xmp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/readme.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/structure.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.apetag.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.id3v1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.id3v2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.lyrics3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.metaflac.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.real.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/getid3/write.vorbiscomment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/html2text/html2text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmLawed/htmLawed.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmLawed/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/CREDITS'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/CustomFilters.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Arborize.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrCollections.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Clone.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/AlphaValue.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Background.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/BackgroundPosition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Border.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Color.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Composite.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/DenyElementDecorator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Filter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Font.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/FontFamily.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Ident.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/ImportantDecorator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Length.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/ListStyle.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Multiple.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Number.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/Percentage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/TextDecoration.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS/URI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/CSS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Enum.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Bool.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Color.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/FrameTarget.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/ID.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Length.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/LinkTypes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/MultiLength.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Nmtokens.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/HTML/Pixels.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Integer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Lang.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Switch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/Text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/Email/SimpleCheck.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/Email.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/Host.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/IPv4.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI/IPv6.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef/URI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrDef.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Background.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/BdoDir.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/BgColor.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/BoolToCSS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Border.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/EnumToCSS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/ImgRequired.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/ImgSpace.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Input.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Lang.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Length.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Name.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/NameSync.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Nofollow.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/SafeEmbed.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/SafeObject.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/SafeParam.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/ScriptRequired.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/TargetBlank.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform/Textarea.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTransform.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrTypes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/AttrValidator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Bootstrap.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Chameleon.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Custom.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Empty.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/List.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Optional.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Required.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/StrictBlockquote.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef/Table.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ChildDef.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Builder/ConfigSchema.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Builder/Xml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Interchange/Directive.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Interchange/Id.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Interchange.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/InterchangeBuilder.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.AllowedClasses.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.AllowedFrameTargets.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.AllowedRel.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.AllowedRev.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.ClassUseCDATA.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.DefaultImageAlt.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.DefaultInvalidImage.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.DefaultInvalidImageAlt.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.DefaultTextDir.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.EnableID.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.ForbiddenClasses.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.IDBlacklist.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.IDBlacklistRegexp.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.IDPrefix.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Attr.IDPrefixLocal.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.AutoParagraph.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.Custom.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.DisplayLinkURI.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.Linkify.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.PurifierLinkify.DocURL.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.PurifierLinkify.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.RemoveEmpty.RemoveNbsp.Exceptions.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.RemoveEmpty.RemoveNbsp.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.RemoveEmpty.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/AutoFormat.RemoveSpansWithoutAttributes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Cache.DefinitionImpl.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Cache.SerializerPath.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Cache.SerializerPermissions.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.AggressivelyFixLt.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.AllowHostnameUnderscore.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.CollectErrors.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.ColorKeywords.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.ConvertDocumentToFragment.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.DirectLexLineNumberSyncInterval.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.DisableExcludes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.EnableIDNA.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.Encoding.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.EscapeInvalidChildren.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.EscapeInvalidTags.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.EscapeNonASCIICharacters.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.HiddenElements.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.Language.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.LexerImpl.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.MaintainLineNumbers.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.NormalizeNewlines.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.RemoveInvalidImg.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.RemoveProcessingInstructions.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Core.RemoveScriptContents.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.AllowedFonts.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.AllowedProperties.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.AllowImportant.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.AllowTricky.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.DefinitionRev.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.ForbiddenProperties.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.MaxImgLength.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.Proprietary.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/CSS.Trusted.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.Custom.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.ExtractStyleBlocks.Escaping.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.ExtractStyleBlocks.Scope.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.ExtractStyleBlocks.TidyImpl.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.ExtractStyleBlocks.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Filter.YouTube.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Allowed.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.AllowedAttributes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.AllowedComments.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.AllowedCommentsRegexp.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.AllowedElements.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.AllowedModules.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Attr.Name.UseCDATA.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.BlockWrapper.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.CoreModules.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.CustomDoctype.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.DefinitionID.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.DefinitionRev.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Doctype.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.FlashAllowFullScreen.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.ForbiddenAttributes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.ForbiddenElements.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.MaxImgLength.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Nofollow.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Parent.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Proprietary.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.SafeEmbed.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.SafeIframe.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.SafeObject.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.SafeScripting.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Strict.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.TargetBlank.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.TidyAdd.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.TidyLevel.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.TidyRemove.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.Trusted.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/HTML.XHTML.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/info.ini'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.CommentScriptContents.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.FixInnerHTML.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.FlashCompat.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.Newline.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.SortAttr.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Output.TidyFormat.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/Test.ForceNoIconv.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.AllowedSchemes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.Base.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DefaultScheme.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DefinitionID.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DefinitionRev.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.Disable.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DisableExternal.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DisableExternalResources.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.DisableResources.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.Host.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.HostBlacklist.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.MakeAbsolute.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.Munge.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.MungeResources.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.MungeSecretKey.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.OverrideAllowedSchemes.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema/URI.SafeIframeRegexp.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/schema.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/Validator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema/ValidatorAtom.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ConfigSchema.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ContentSets.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Context.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/CSSDefinition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Definition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Decorator/Cleanup.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Decorator/Memory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Decorator/Template.php.in'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Decorator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Null.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/CSS/4.6.0,24166bfe16a0cc6bd18d813b83121ef2eaf16545,1.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/HTML/4.6.0,bd08c5afbc77123dbd4e9e026a723c450e9f844b,1.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer/URI/4.6.0,8d03c8ec0e84e7feb92afd4c0f1735841b5fdacf,1.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache/Serializer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCache.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DefinitionCacheFactory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Doctype.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/DoctypeRegistry.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ElementDef.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Encoder.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/EntityLookup/entities.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/EntityLookup.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/EntityParser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ErrorCollector.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/ErrorStruct.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Filter/ExtractStyleBlocks.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Filter/YouTube.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Filter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Generator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLDefinition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Bdo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/CommonAttributes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Edit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Forms.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Hypertext.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Iframe.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Legacy.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/List.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Name.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Nofollow.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/NonXMLCommonAttributes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Object.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Presentation.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Proprietary.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Ruby.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/SafeEmbed.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/SafeObject.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/SafeScripting.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Scripting.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/StyleAttribute.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tables.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Target.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/TargetBlank.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/Name.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/Proprietary.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/Strict.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/Transitional.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/XHTML.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy/XHTMLAndHTML4.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/Tidy.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule/XMLCommonAttributes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModule.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/HTMLModuleManager.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/IDAccumulator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/AutoParagraph.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/DisplayLinkURI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/Linkify.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/PurifierLinkify.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/RemoveEmpty.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/RemoveSpansWithoutAttributes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector/SafeObject.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Injector.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/classes/en-x-test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/messages/en-x-test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/messages/en-x-testmini.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language/messages/en.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Language.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/LanguageFactory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Length.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Lexer/DirectLex.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Lexer/DOMLex.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Lexer/PH5P.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Lexer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Node/Comment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Node/Element.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Node/Text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Node.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/PercentEncoder.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer/ConfigForm.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer/ConfigForm.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer/ConfigForm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer/CSSDefinition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer/HTMLDefinition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Printer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/PropertyList.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/PropertyListIterator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Queue.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/Composite.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/Core.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/FixNesting.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/MakeWellFormed.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/RemoveForeignElements.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy/ValidateAttributes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Strategy.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/StringHash.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/StringHashParser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/TagTransform/Font.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/TagTransform/Simple.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/TagTransform.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/Comment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/Empty.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/End.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/Start.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/Tag.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token/Text.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Token.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/TokenFactory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/UnitConverter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIDefinition.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/DisableExternal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/DisableExternalResources.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/DisableResources.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/HostBlacklist.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/MakeAbsolute.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/Munge.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter/SafeIframe.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIFilter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIParser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/data.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/file.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/ftp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/http.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/https.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/mailto.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/news.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme/nntp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URIScheme.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/URISchemeRegistry.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/VarParser/Flexible.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/VarParser/Native.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/VarParser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/VarParserException.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier/Zipper.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.auto.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.autoload.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.composer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.func.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.includes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.kses.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.path.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/HTMLPurifier.safe-includes.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/INSTALL'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/htmlpurifier/NEWS'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/http/http.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/http/LICENSE.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/oauth/oauth_client.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/oauth/oauth_configuration.json'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/class.phpmailer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/class.pop3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/class.smtp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-br.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-ca.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-cz.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-de.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-dk.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-en.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-es.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-et.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-fi.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-fo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-fr.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-hu.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-it.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-ja.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-nl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-no.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-pl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-ro.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-ru.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-se.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/language/phpmailer.lang-tr.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/phpmailer/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/autoloader.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn/idna_convert.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn/LICENCE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn/npdata.ser'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/idn/ReadMe.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Author.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache/Base.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache/DB.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache/File.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache/Memcache.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache/MySQL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Cache.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Caption.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Category.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Content/Type/Sniffer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Copyright.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Core.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Credit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Decode/HTML/Entities.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Enclosure.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/File.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/gzdecode.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/HTTP/Parser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/IRI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Item.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Locator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Misc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Net/IPv6.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Parse/Date.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Parser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Rating.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Registry.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Restriction.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Sanitize.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/Source.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie/XML/Declaration/Parser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/library/SimplePie.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/LICENSE.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/simplepie/README.markdown'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/ChangeLog'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/examples/1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/examples/tables.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/makeDocs.pl'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/phputf8.pod'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/print.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/docs/screen.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/exp/regexunicode.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/mbstring/core.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/native/core.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/ord.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/strcasecmp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/strcspn.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/stristr.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/strrev.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/strspn.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/str_ireplace.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/str_pad.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/str_split.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/substr_replace.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/TODO.tsk'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/trim.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/ucfirst.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/ucwords.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utf8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/ascii.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/bad.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/patterns.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/position.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/specials.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/unicode.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/utf8/utils/validation.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/lib/ZipLib.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/logs/access.log'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/logs/captcha.log'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/logs/error.log'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/logs/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/logs/spamx.log'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/bad_behavior2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/templates/entry.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/templates/log.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/bad_behavior2/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/calendar.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/danish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/japanese.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/korean.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/korean_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/russian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/russian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/addevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/addeventoption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/addremoveevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/admin/batchadmin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/admin/eventeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/calendar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/calendarday.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/calendarevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/calendarweek.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/column.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/dayview.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/quickaddform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/dayview/singleevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/editpersonalevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/eventdetails.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/events.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/mastercalendaroption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/personalcalendaroption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/submitevent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/weekview/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/weekview/events.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/templates/weekview/weekview.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/calendar/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/captcha.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/class/captcha.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/class/error.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/class/filter.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/class/picatchalib.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/class/recaptchalib.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg0.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg0.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg1.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg3.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg4.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg5.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg7.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg7.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg8.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg8.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/backgrounds/bg9.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/fonts/bluehigl.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/fonts/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/fonts/typewriterA602.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/fonts/zombnze.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/0EYP0S.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/1F770D.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/28XOYI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/2LDUMD.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/47TXJC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/4ITVAP.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/4JKOGQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/5E66T1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/5LSG1C.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/6URYYP.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/7G1AG0.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/7GZY5S.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/7Q2WOZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/7SMW7J.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/83EY3L.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/8C99ZZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/8MNIAX.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/8N91KL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/8NFLWQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/8RL5MD.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/9KR3EJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/BI1ZCZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/BPHOX9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/BRWLVK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/BZTIGV.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/C0HK4F.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/C2QOUK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/CFE1YM.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/CJANGI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/CQY9FX.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/CXUH5S.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/CYO0Y1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/DHGFOZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/DQFRUI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/DUZCN2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/E5SZ52.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ECGLOZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/EE37I4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ELWSDN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/F6A0KP.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/F7VU1K.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/FZAL8O.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/G5DCR5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/G9J7VC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/GBHHGT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/GFACI5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/GP6LL9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/GXIRNW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/H5FLY1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/HH0NAF.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/HWYMU6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/I0VFY9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/I0W79K.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/I121OQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/I1AZAU.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/I7CQIR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/IIOGVW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/IKF3O4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/IKJM7C.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/imageset.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/INNH12.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/IO0H0L.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/IWXXTN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/J7XDFF.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/JF4UH8.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/JSMSI9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/K1LUBX.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/K55DZL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/KIFH52.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/KVKZU2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/L3QMM1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/LRW7O3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/MFWUDW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ML976T.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/N1KL1P.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/O3UV7A.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/OB87BK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ODH566.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/OE8PKO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/OOHUIW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/PSWO3K.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/PZ4CS0.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/Q1PAGZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/R8OVM4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/RAKUHA.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/SK908O.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/TDGQSM.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/TG3ZTE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/U4IG9B.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/U5R7PW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/UJ97BE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/VANJZK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/VN6QKH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/VPLW5R.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/VTZDK1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/VUYFUH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/WJDUK2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/WP0QYS.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/XDIYL2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/XUKG66.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/YE9U9N.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/YQ73D3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/YTWL2C.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ZNF56M.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/default/ZYO016.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/28W35R.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/2H54BP.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/2ODBIK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/2OHTB6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/2UN2T4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/2Y3NI3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/329C4E.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/34FAIL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/38U3LL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/3G9FNT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/3TUZJ5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/3V3GMY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/3V8BLH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/3Z6SK9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/459992.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/49BO96.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/4H822P.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/4KIPVR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/4LA3H3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/4MMRBL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/4XRB9L.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/53ZZPJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/56PMYX.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/58JZ9A.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/58ON5H.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/5MJ9N9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/5NMMFE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/5SFQCO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/5WHXMU.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/67ZXOX.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/6C66Q2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/6CNFKI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/6FIMTD.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/6NGIKQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/6O6VB4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/77FUGQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/7RBU2D.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/87G9RH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/8NVPY8.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/8Q6GV2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/8STMHC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/8VE4O2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/93JAMW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/93YKM2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/95U7H6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/9EWAEL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/9PKLDW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/9TERC6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/A3V3KJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/A6T4IB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AGMYWR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AGTHBU.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AL4HCB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AQ6NB4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ASJ87E.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AUYLWL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/AX6KYY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/B6XKWH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/B79HEZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/BAEOW7.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/BC4TOH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/BJ6LFG.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/BN7ZRO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/BQLNW6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/C949YY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/CECTCH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/CRRE6H.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/CWOTHO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/CXXJTI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/D37T48.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/D3NZL3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/DDKKSL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/DDLFG4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/DIKHR8.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/DOUBU3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/DSM83V.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/E3BDIT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/E6VWIQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/EIP9PC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/EMXJY9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/EN9YX2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ERMUJA.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ETSXD5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/EWQ6A3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/FCWVWD.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/FDTCIL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/FEOBB7.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/FOSL9J.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/FUMH29.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/G26ZP5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/G3SF8M.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/G6XV2R.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/G7KUX9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/G8WAR9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/GCOLK5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/GJHB5R.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/GJQ3G5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/GLIMR5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/GU7V62.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/HI93J3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/HOG2BL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/HU799L.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/IGG7UF.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/imageset.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ISX372.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/IXZZLY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/IY5KJV.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/J6CMM3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/J7WP7J.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/JBTJF3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/JFZLL3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/JQWJLK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/JSZCHO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/JY8MM4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/K2KHPK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/K6NE8U.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KCDNFJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KEIS6E.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KEM9SG.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KN4989.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KO4RC7.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/KV63PE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/L234QN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/L43JG4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/L7U3BI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/LJHH4H.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/LWSOOJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/MCZKYO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/MOC7DS.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/MZTZY4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/NC7P9O.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/NNPS6I.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/NVJBSZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/O48FJE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/O6T8IF.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/O6WTME.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/OCYIRC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/OU86ZK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/P6GGZJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/PBP2Q4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/PBRNUG.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/PCFBTY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/PTYHWT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q3B6MJ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q5WE5N.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q6QRRQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q88EAE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q8PCFZ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q8TKZ9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Q9F2JQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/QGT2FA.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/QPDO77.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/QRSZCL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/QZJ6RF.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RAEJRW.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RB8JS2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RKHHNN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RMAV6A.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RNAZST.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/RNZO9K.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/S4TF7B.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/SBO3VK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/SIKZ54.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/SNOGA2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/SQ4IMD.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/STU4JI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/TRQPRG.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/U2QXNT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/U6G79E.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/UIATQY.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/UQUIIR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/UX46L9.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/VDNZQE.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/VHOI4X.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/VJB6ZG.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/VLAV3W.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/VZK7RT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/W37HUI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/W9IWIN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/W9PMYN.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/WOG89D.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/WPDXTB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/WTIK8Z.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/WUEVL6.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/X553A4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/XEDHGI.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/XMG3RK.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/XMTPRR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/XUGAHV.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/XXRD7B.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YHFA7O.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YJL787.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YLAMYH.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YO4ODC.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YSOYZQ.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YV9UVB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YYHLY8.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/YZU4BO.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/Z6J85P.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ZQJOTV.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/images/static/simple/ZRTIL5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/admin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/administration.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_calendar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_comment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_contact.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_emailstory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_forum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_links.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_mediagallery.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_registration.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_story.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/captcha_token.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/templates/install.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/captcha/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/ckeditor.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/README.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_block.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_comment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_contact.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_email.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_sp.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_story.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/templates/ckeditor_submitstory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/ckeditor/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/commentfeeds.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/config.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/license'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/commentfeeds/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/config.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/filemgmt.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/dlformat.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/errorhandler.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/functions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/header.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/textsanitizer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/include/xoopstree.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/danish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/filelisting.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/filelisting_category.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/filelisting_record.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/filelisting_subcategory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/notifyemail.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/templates/sortmenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/filemgmt/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/css/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/forum.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/include/admin.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/include/format.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/include/forum.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/include/topic.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/include/upload.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/js/mootips.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates/mysql_1.0_to_2.0.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates/mysql_2.0_to_2.2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates/mysql_2.2_to_2.3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates/mysql_2.3_to_2.3RC4.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/sql/updates/mysql_2.3_to_2.5RC1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/banip_mgmt.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/boards.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/boards_delete.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/boards_edtcategory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/boards_edtforum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/footer.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/index.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/ips.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/ips_unban.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/ip_records.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/messages.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/message_line.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/migratestories.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/migrate_records.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/moderators.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/mod_add.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/mod_record.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/phpbb3_migrate_confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/phpbb3_migrate_db.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/radiosetting_option.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/ranksetting_option.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/rating.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/settings.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/setting_option.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/admin/textsetting_option.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/alertmsg.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks/block_displayline.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks/centerblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/blocks/latestpostsblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/ckeditor_forum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/footer.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/forum_legend.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/forum_rules.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/forum_time.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/footer/forum_users.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/forum_jump.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/forum_search.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/gettopic.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/homepage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/mod_confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/navbar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/notifymessage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/notifymessage_text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/posteditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/reports/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/reports/notifications.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/search_results.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/signature_profile.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/smilies.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/statusmessage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/tinymce_forum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/topic-left.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/topiclisting.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/topic_full.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/topic_preview.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/userprefs/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/templates/userprefs/profile_user_settings.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/forum/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/korean.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/korean_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/polish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/polish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/russian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/russian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/links.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/categoryeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/categorylist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/catitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/admin/linkeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categoryactivecol.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categorycol.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categorydropdown.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categorylinks.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categorynavigation.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/categoryrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/linkdetails.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/links.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/pagenavigation.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/templates/submitlink.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/links/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/climport.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/config.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/docs/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/albumedit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/autotag.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/batch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/caption.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/centerblock.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/classAlbum.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/classFrame.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/classMedia.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/comment.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/exif.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/ftpmedia.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/global.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/init.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/JPEG.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/lib-batch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/lib-exif.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/lib-media.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/lib-upload.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/lib-watermark.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/canon.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/fujifilm.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/gps.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/nikon.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/olympus.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/panasonic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/makers/sanyo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/mediamanage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/mgindex-all.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/mgindex.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/newmedia.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/profile.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/rebuild.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/remote.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/rotate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/rssfeed.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/sort.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/include/stats.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/finnish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/italian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/japanese.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/norwegian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/polish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/polish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/language/turkish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/mediagallery.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/staticpage.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/administration.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/category.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/catitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/cat_noitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/cfgedit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/createmembers.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/editalbum_formats.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/editavdefaults.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/editcategory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/editdefaults.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/editmember.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/exif_tags.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/export.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/massdelete.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/mg_navigation.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/purgealbums.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/quotaconfirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/quotareport.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/rssedit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/sessions.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/sessitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/sess_noitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/staticsortalbums.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/staticsortmedia.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/success.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/thumbs.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/usage_menu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/usage_rpt.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/admin/useredit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/albumblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/albumrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_album_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_album_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_comment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_keywords.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_podcast.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_rating.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_body_media_cell_view.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/album_page_noitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/asf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/autotag.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/autotag_nb.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/autotag_ss.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/batch_caption_edit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/batch_caption_media_items.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/batch_percent.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/batch_progress.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/cb_featured_album.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/cb_featured_album.thtml.2'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/cleanlist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/deletealbum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/digibug.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/editalbum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/editalbum_admin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_album_permissions.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_album_perm_member.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_asf_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_flv_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_mov_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_mp3_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/edit_swf_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/embed.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/enroll.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/envcheck.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/error.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/exif_detail.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/featured_album.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/filecheck.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/filelist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/flvfp.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/flvmg.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/flvpopup.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/fsat.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/fslideshow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/ftpimport.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/ftpupload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gallery_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gallery_page_body_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gallery_page_body_2.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gallery_page_body_3.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gallery_page_noitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/getcard.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/global_album_attr.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/global_album_perm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/gl_story_import.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/html5upload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/convert_4images_settings.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/convert_inmemoriam.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/import_config_dir.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/import_coppermine.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/import_gallery2_parms.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/import_gallery_dir.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/import/import_select_items.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/index-all.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/install.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/media-fi.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mediablock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mediaedit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mediaitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/medialink.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mediamanage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mediarow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/modemail.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/moderate.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mp3_podcast.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mp3_qt.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mp3_swf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/mp3_wmp.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/notifymessage_html.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/notifymessage_text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/pc-error.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/pc_edit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/pc_preview.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/playall_xspf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/postcard.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/profile_userprefs.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/property.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/quicktime.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/random_block.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/remoteupload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/search.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/search_results.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/search_results2.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/slideshow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/slideshow_empty.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/sortalbum.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/staticsort.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/swf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/swfobject.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/album_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/album_page_body_album_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/album_page_body_media_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/view_audio.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/view_image.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/clean/view_video.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist/album_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist/album_page_body_album_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist/album_page_body_album_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist/album_page_body_media_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/filelist/album_page_body_media_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/album_page_body_media_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/album_page_body_media_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/album_page_body_media_cell_comment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/lightbox/medialink.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/album_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/album_page_body_album_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/album_page_body_album_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/album_page_body_media_cell.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/album_page_body_media_cell_1.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/podcast/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/simpleviewer/album_page.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/themes/simpleviewer/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/upload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/userprefs.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/userupload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/useruploadstatus.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_asf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_audio.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_flv.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_flv_light.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_flv_light_stream.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_image.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_image_detail.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_mp3_flv.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_mp3_qt.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_mp3_swf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_mp3_wmp.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_quicktime.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_swf.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/view_video.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/wmitems.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/wmmanage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/wm_upload.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/xpcreate.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/xplist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/xplogin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/xppublish.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/templates/xspf_radio.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/tmp/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/UPGRADE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/mediagallery/uploads/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/danish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/korean.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/korean_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/russian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/russian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/polls.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin/pollansweroption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin/polleditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/admin/pollquestions.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollanswer.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollcomments.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/polllist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollquestion.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollquestions.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollresult.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollvotes_bar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/templates/pollvotes_num.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/polls/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/BaseAdmin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/BaseCommand.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/BlackList.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/DeleteComment.Action.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/Developer.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/EditBlackList.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/EditHeader.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/EditIP.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/EditIPofURL.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/Header.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/IP.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/IPofUrl.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/farsi_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/french_france.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/french_france_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/italian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/italian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/russian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/russian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/MailAdmin.Action.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/MassDelete.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/MassDelTrackback.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SFS.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SFS.Misc.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SFSbase.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SFSreport.Action.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SLV.Examine.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SLVbase.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SLVreport.Action.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/SLVwhitelist.Admin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/spamx.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/templates/admin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/templates/install.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/spamx/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/autoinstall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/functions.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/install_defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/custom/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/czech.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/czech_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/danish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/danish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/dutch_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/estonian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/estonian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/farsi_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/finnish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/french_canada.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/french_canada_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/german_formal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/german_formal_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/german_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/hebrew_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/italian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/italian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/japanese_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/korean.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/korean_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/polish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/polish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/portuguese_brazil.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/portuguese_brazil_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/slovenian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/slovenian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/spanish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/swedish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/swedish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/turkish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/turkish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/ukrainian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/ukrainian_koi8-u.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/language/ukrainian_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/plugin.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/services.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/sql/mysql_install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/staticpages.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/admin/editor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/centerblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/printable.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/spcomments.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/templates/staticpage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/plugins/staticpages/upgrade.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/readme'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/default_content.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/mysql_tableanddata.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/geeklog_mysql_1.4.1_to_1.5.0.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.0.1_to_1.1.0.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.1.2_to_1.1.3.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.1.3_to_1.1.4.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.1.4_to_1.1.5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.1.6_to_1.1.7.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/sql/updates/mysql_1.2.2_to_1.3.0.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/base.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/cipher.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/conf.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/glfwiki.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/lang.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/topic.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/user.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/wikipedia.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/autotags/youtube.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/authentication/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/authentication/ldap/config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/authentication/ldap/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/authentication/LDAP.auth.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/calendar.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/config.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/conversion.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/date.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/downloader.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/filter.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/listfactory.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/menu.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/navbar.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/oauthhelper.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/association.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/consumer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/COPYING'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/httpclient.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/interface.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/oid_parse.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/oid_util.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/server.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openid/trustroot.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/openidhelper.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/output.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/plugin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/search.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/searchcriteria.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/searchplugin.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/story.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/template.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/timer.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/upload.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/classes/url.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/databases/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/databases/mysql.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/databases/mysqli.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/imglib/gd_image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/imglib/im_image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/imglib/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/imglib/lib-image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/imglib/pbm_image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-admin.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-autotag.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-bbcode.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-comment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-compatibility.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-custom.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-database.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-glfusion.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-mbyte.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-menu.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-pingback.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-plugins.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-rating.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-security.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-sessions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-story.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-syndication.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-trackback.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-user.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-webservices.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/lib-widgets.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/memberdetail.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Archive/Tar.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/Anonymous.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/CramMD5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/DigestMD5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/External.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/Login.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/Plain.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL/SCRAM.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Auth/SASL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Console/Getopt.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Date.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer/Exception/InvalidResponse.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer/Request.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer/Response.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Consumer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Exception/NotImplemented.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Message.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider/Exception/InvalidRequest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider/Request.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Provider/Response.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/HMAC/SHA1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/PLAINTEXT.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature/RSA/SHA1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Signature.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Store/Consumer/CacheLite.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Store/Consumer/Interface.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth/Store/Data.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/OAuth.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request/Listener.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Adapter/Curl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Adapter/Mock.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Adapter/Socket.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Adapter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/CookieJar.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/MultipartBody.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Observer/Log.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/Response.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/SocketWrapper.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2/SOCKS5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/HTTP/Request2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/Header.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/Packet.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/Question.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/Resolver.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/A.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/AAAA.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/CNAME.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/HINFO.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/LOC.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/MX.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/NAPTR.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/NS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/PTR.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/RP.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/SOA.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/SPF.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/SRV.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/TSIG.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR/TXT.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS/RR.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/DNS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/SMTP.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/Socket.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/URL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Net/URL2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/OS/Guess.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Autoloader.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Builder.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/ChannelFile/Parser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/ChannelFile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Auth.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Auth.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Build.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Build.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Channels.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Channels.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Config.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Install.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Mirror.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Mirror.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Package.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Package.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Pickle.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Pickle.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Registry.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Registry.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Remote.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Remote.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command/Test.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Command.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Dependency.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Dependency2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/DependencyDB.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Downloader/Package.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Downloader.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/ErrorStack.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/FixPHP5PEARWarnings.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Frontend/CLI.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Frontend.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Cfg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Cfg.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Data.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Data.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Doc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Doc.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Ext.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Ext.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Php.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Php.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Script.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Script.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Src.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Src.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Test.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Www.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role/Www.xml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer/Role.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Installer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Generator/v1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Generator/v2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Parser/v1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/Parser/v2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/v1.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/v2/rw.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/v2/Validator.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile/v2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/PackageFile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Packager.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Registry.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Remote.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/REST/10.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/REST/11.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/REST/13.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/REST.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/RunTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Postinstallscript/rw.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Postinstallscript.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Replace/rw.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Replace.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Unixeol/rw.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Unixeol.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Windowseol/rw.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Task/Windowseol.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Validate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/Validator/PECL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR/XMLParser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/PEAR5.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/pearcmd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/peclcmd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/pear.bat'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/pear.sh'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/pearcmd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/peardev.bat'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/peardev.sh'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/pecl.bat'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/pecl.sh'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/scripts/peclcmd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Bitly.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Digg.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception/CouldNotExpand.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception/CouldNotShorten.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception/InvalidOptions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception/NotImplemented.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception/UnknownService.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Interface.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Isgd.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Shortie.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/TinyURL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL/Trim.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Services/ShortURL.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph/Manipulator/AcyclicTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph/Manipulator/TopologicalSorter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph/Node.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/Structures/Graph.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/System.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/XML/RPC/Dump.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/XML/RPC/Server.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/XML/RPC.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'private/system/pear/XML/Util.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/404.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/auth.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/autotag.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/autotag_upload.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/block.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/clearctl.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/configuration.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/database.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/envcheck.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/filecheck.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/getorder.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/group.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/config-install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/configinfo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/dvlpupdate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/fusionrescue.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/help.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/include/install.lib.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/include/template-lite.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/info.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/bulgarian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/chinese_simplified_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/chinese_traditional_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/dutch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/english_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/german.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/indonesian.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/polish.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/polish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/spanish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/language/swedish_utf-8.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow-back.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow-next.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow-recheck.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow_down.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/arrow_open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/bottom-l-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/bottom-r-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/check.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/error.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/gl_moomenu1-bg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/gl_moopngfix.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/header-bg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/help.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/ie6.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/ie7.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/installlogo.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/mootools-release-1.11.packed.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/steplist-bottom.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/steplist-repeat.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/steplist-top.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/top-l-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/top-r-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/layout/top.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/success.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/checkenvironment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/contentplugins.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/error.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/footer.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/geeklogpathsetting.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/languagetask.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/pathsetting.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/templates/siteinformation.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/install/toinnodb.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/logo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/logview.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/mail.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/menu.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/moderation.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/bad_behavior2/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/bad_behavior2/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/calendar/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/calendar/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/captcha/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/captcha/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/ckeditor/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/ckeditor/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/commentfeeds/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/commentfeeds/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/filemgmt/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/filemgmt/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/boards.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/import.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/ips.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/messages.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/migrate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/mods.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/phpbb3_migrate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/rating.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/resyncall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/userrating.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/forum/userrating_detail.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/links/category.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/links/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/links/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/avdefaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/category.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/cfgedit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/check.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/createmembers.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/defaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/edituser.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/exif_admin.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/export.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/4images/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Coppermine/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Gallery1/Gallery1DataParser.class'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Gallery1/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/gallery2/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/geekary/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/gl_story/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/importers/Inmemoriam/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/install_doc.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/maint.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/massdelete.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/member.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/navigation.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/purgealbums.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/queue.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/quota.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/quotareport.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/redX.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/resetdefaults.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/resetmembers.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/rss.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/rssrebuild.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/sessions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/staticsortalbums.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/staticsortmedia.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/success.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/usage_rpt.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/mediagallery/xppubwiz.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/polls/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/polls/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx/images/spamx.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/spamx/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/staticpages/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins/staticpages/install.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugins.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/plugin_upload.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/prefeditor.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/resetrating_rpc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/sectest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/sfs.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/story.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/syndication.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/topic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/trackback.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/user.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/admin/vercheck.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/article.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/backend/glfusion.rss'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/backend/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/banned.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/blackhole.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/blacklist.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/common_tests.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/core.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/functions.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/google.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/housekeeping.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/konqueror.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/lynx.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/movabletype.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/mozilla.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/msie.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/msnbot.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/opera.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/post.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/responses.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/safari.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/screener.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/trackback.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/version.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/whitelist.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior/yahoo.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/bad-behavior-glfusion.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/images/bad_behavior2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/bad_behavior2/README.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/event.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/images/calendar.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/images/delete_event.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/calendar/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/captcha.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/captcha.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/class/captcha.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/class/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/captcha/reload.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/adapters/jquery.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/ckeditor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/config.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/contents.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/af.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ar.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/bg.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/bn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/bs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/cs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/cy.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/da.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/de.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/el.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/en-au.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/en-ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/en-gb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/eo.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/es.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/et.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/eu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/fa.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/fi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/fo.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/fr-ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/fr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/gl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/gu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/he.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/hi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/hr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/hu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/id.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/is.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/it.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ja.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ka.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/km.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ko.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ku.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/lt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/lv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/mk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/mn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ms.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/nb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/nl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/no.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/pl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/pt-br.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/pt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ro.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ru.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/si.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sq.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sr-latn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/sv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/th.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/tr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/ug.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/uk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/vi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/zh-cn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/lang/zh.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/LICENSE.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/a11yhelp.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ar.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/bg.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/cs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/cy.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/da.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/de.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/el.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/en-gb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/eo.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/es.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/et.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/fa.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/fi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/fr-ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/fr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/gl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/gu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/he.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/hi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/hr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/hu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/id.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/it.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ja.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/km.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ko.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ku.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/lt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/lv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/mk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/mn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/nb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/nl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/no.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/pl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/pt-br.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/pt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ro.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ru.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/si.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sq.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sr-latn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/sv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/th.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/tr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/ug.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/uk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/vi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/zh-cn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/zh.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/_translationstatus.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/a11yhelp/dialogs/lang/tt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about/dialogs/about.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about/dialogs/hidpi/logo_ckeditor.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/about/dialogs/logo_ckeditor.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/clipboard/dialogs/paste.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/colordialog/dialogs/colordialog.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/dialog/dialogDefinition.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/div/dialogs/div.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/fakeobjects/images/spacer.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/bower.json'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/default.config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/filemanager.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/filemanager.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/filemanager.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/JSON.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/bg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/addNoise.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/applyConvolution.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/applyFilter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/applyMask.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/asGrayscale.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/asNegative.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/autoCrop.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/correctGamma.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/crop.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/flip.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/getCanvas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/getChannels.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/getMask.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/merge.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/mirror.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/resize.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/resizeCanvas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/rotate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/roundCorners.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demos/unsharp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/demo_screen.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/font.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/COPYRIGHT.TXT'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/local.conf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/README.TXT'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/RELEASENOTES.TXT'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/Vera.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraBd.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraBI.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraIt.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraMoBd.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraMoBI.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraMoIt.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraMono.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraSe.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/fonts/VeraSeBd.ttf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/AngleField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/CheckboxField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/CheckboxSetField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/ColorField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/CoordinateField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/Demo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/Field.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/FileSelectField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/FloatField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/FormatSelectField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/IntField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/Request.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/helpers/SelectField.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/1-rainbow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/2-blue-alpha.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/3-smiley.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/4-color-hole.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/5-circle.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/6-logo.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/7-overlay.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/bg03.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/images/fgnl.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/masks/mask-circle.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/masks/mask-circle.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/masks/mask-diagonal.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/demo/masks/mask-smiley.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/classtrees_Exceptions.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/classtrees_Internal-Mappers.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/classtrees_Internal-Operations.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/classtrees_Internals.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/classtrees_WideImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex_Exceptions.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex_Internal-Mappers.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex_Internal-Operations.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex_Internals.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/elementindex_WideImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/errors.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_Exception.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_GDFunctionResultException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidCanvasMethodException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidCoordinateException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidFontFileException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidImageDimensionException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidImageHandleException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_InvalidImageSourceException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_NoFontException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_UnknownErrorWhileMappingException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_UnknownImageOperationException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Exceptions/WideImage_UnsupportedFormatException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_BMP.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_GD.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_GD2.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_GIF.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_JPEG.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_PNG.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_Mapper_TGA.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_vendor_de77_BMP.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/WideImage_vendor_de77_TGA.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---BMP.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---GD.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---GD2.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---GIF.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---JPEG.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---PNG.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_Mapper---TGA.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_vendor---de77---BMP.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Mappers/_vendor---de77---TGA.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_AddNoise.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_ApplyConvolution.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_ApplyFilter.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_ApplyMask.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_AsGrayscale.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_AsNegative.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_AutoCrop.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_CopyChannelsPalette.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_CopyChannelsTrueColor.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_CorrectGamma.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Crop.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Flip.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_GetMask.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_InvalidFitMethodException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_InvalidResizeDimensionException.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Merge.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Mirror.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Resize.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_ResizeCanvas.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Rotate.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_RoundCorners.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/WideImage_Operation_Unsharp.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---AddNoise.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---ApplyConvolution.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---ApplyFilter.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---ApplyMask.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---AsGrayscale.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---AsNegative.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---AutoCrop.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---CopyChannelsPalette.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---CopyChannelsTrueColor.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---CorrectGamma.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Crop.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Flip.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---GetMask.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Merge.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Mirror.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Resize.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---ResizeCanvas.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Rotate.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---RoundCorners.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internal-Operations/_Operation---Unsharp.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals/WideImage_Coordinate.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals/WideImage_MapperFactory.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals/WideImage_OperationFactory.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals/_Coordinate.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/Internals/_OperationFactory.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/li_Exceptions.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/li_Internal-Mappers.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/li_Internal-Operations.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/li_Internals.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/li_WideImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/media/background.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/media/empty.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/media/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_Canvas.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_Font_GDF.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_Font_PS.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_Font_TTF.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_Image.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_PaletteImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/WideImage_TrueColorImage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Canvas.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Exception.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Font---GDF.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Font---PS.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Font---TTF.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_Image.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_MapperFactory.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_PaletteImage.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_TrueColorImage.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/doc/WideImage/_WideImage.php.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/gpl.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lgpl.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Canvas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Coordinate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Exception.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Font/GDF.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Font/PS.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Font/TTF.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Image.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/BMP.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/GD.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/GD2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/GIF.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/JPEG.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/PNG.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Mapper/TGA.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/MapperFactory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/AddNoise.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/ApplyConvolution.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/ApplyFilter.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/ApplyMask.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/AsGrayscale.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/AsNegative.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/AutoCrop.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/CopyChannelsPalette.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/CopyChannelsTrueColor.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/CorrectGamma.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Crop.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Flip.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/GetMask.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Merge.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Mirror.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Resize.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/ResizeCanvas.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Rotate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/RoundCorners.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/Operation/Unsharp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/OperationFactory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/PaletteImage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/TrueColorImage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/vendor/de77/BMP.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/vendor/de77/TGA.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/lib/WideImage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-blue-alpha.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-color-hole.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-color-hole.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-rainbow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-red-spot-half-cut.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-red-spot.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-red-transparent.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-rgbyg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x100-square-overlay.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/100x50-rgbt.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/75x25-gray.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/actually-a-png.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp/rainbow-16b-x.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp/rainbow-16b.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp/rainbow-24b.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp/rainbow-32b.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/bmp/rainbow-palette-rle.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/fakeimage.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/fgnl-bmp.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/fgnl.bmp'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/fgnl.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/image-actually-foo.foo2'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/image.foo'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/logo.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/images/splat.tga'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/run.bat'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/run.sh'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/test-init.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/CanvasTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/CoordinateTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/ImageTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/BMPTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/GD2Test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/GDTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/GIFTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/JPEGTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/PNGTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Mapper/TGATest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/MapperFactoryTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/ApplyConvolutionTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/ApplyFilterTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/ApplyMaskTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/AsGrayscaleTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/AsNegativeTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/AutoCrop.test.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/CorrectGammaTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/CropTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/FlipTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/GetChannelsTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/GetMaskTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/MergeTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/MirrorTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/ResizeCanvasTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/ResizeTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/RotateTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/RoundCornersTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/Operation/UnsharpTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/OperationFactoryTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/PaletteImageTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/TrueColorImageTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/test/tests/WideImageTest.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/inc/vendor/wideimage/VERSION'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/cloudfiles.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/cloudfiles_exceptions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/cloudfiles_http.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/COPYING'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/filemanager.rsc.class.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/filemanager.rsc.config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share/cacert.pem'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share/magic'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share/magic.mgc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share/magic.mime'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/plugins/rsc/share/magic.mime.mgc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/connectors/php/user.config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/accept.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/ajax-loader.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/application_view_icons.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/application_view_list.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/bin_closed.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/bullet_arrow_down.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/bullet_arrow_up.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/download.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/aac.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/avi.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/bmp.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/chm.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/css.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/default.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/dll.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/doc.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/docx.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/fla.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/gif.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/htm.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/html.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/ini.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/jar.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/jpeg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/jpg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/js.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/lasso.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/mdb.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/mov.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/mp3.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/mp4.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/mpg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/ogg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/ogv.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/other_image.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/other_movie.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/other_music.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/other_music2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/pdf.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/php.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/png.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/ppt.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/py.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/rb.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/real.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/reg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/rtf.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/sql.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/swf.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/txt.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/vbs.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/wav.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/webm.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/wma.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/wmv.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/xls.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/xlsx.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/xml.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/xsl.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/zip.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Documents.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Favorites.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Image.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Movie.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Music.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Net.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_ProgramFiles.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/fileicons/_Works.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/folder_add.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/house.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/move.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/parentfolder.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/pencil.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/plus.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/replace.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/reset.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/tag.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/upload.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/images/wait30trans.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/ReadMe.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/.travis.yml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/comment/comment.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/comment/continuecomment.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/dialog/dialog.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/dialog/dialog.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/display/fullscreen.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/display/fullscreen.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/display/placeholder.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/display/rulers.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/closebrackets.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/closetag.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/continuelist.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/matchbrackets.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/matchtags.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/edit/trailingspace.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/brace-fold.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/comment-fold.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/foldcode.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/foldgutter.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/foldgutter.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/indent-fold.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/markdown-fold.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/fold/xml-fold.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/anyword-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/css-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/html-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/javascript-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/python-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/show-hint.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/show-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/sql-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/hint/xml-hint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/coffeescript-lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/css-lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/javascript-lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/json-lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/lint.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/lint/yaml-lint.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/merge/dep/diff_match_patch.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/merge/merge.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/merge/merge.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/mode/loadmode.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/mode/multiplex.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/mode/multiplex_test.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/mode/overlay.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/runmode/colorize.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/runmode/runmode-standalone.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/runmode/runmode.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/runmode/runmode.node.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/scroll/scrollpastend.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/search/match-highlighter.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/search/search.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/search/searchcursor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/selection/active-line.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/selection/mark-selection.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/tern/tern.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/tern/tern.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/tern/worker.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/addon/wrap/hardwrap.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/AUTHORS'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/authors.sh'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/compress'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/lint'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/release'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bin/source-highlight'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/bower.json'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/CONTRIBUTING.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/dynamic-mode.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/keymap/emacs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/keymap/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/keymap/sublime.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/keymap/vim.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/lib/codemirror.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/lib/codemirror.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/lib/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/LICENSE'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/javascript/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/javascript/javascript.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/javascript/json-ld.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/javascript/test.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/mode/meta.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/package.json'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/README.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/3024-day.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/3024-night.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/ambiance-mobile.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/ambiance.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/base16-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/base16-light.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/blackboard.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/cobalt.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/eclipse.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/elegant.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/erlang-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/lesser-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/mbo.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/mdn-like.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/midnight.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/monokai.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/neat.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/night.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/paraiso-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/paraiso-light.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/pastel-on-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/rubyblue.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/solarized.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/the-matrix.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/tomorrow-night-eighties.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/twilight.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/vibrant-ink.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/xq-dark.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/CodeMirror/theme/xq-light.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.config.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.config.js.default'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.liveSearch.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.liveSearch.min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/filemanager.min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery-1.8.3.min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/cut.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/door.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/page_white_copy.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/page_white_delete.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/page_white_edit.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/images/page_white_paste.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/jquery.contextMenu-1.01.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.contextmenu/jquery.contextMenu-1.01.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/application.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/code.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/css.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/db.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/directory.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/doc.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/file.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/film.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/flash.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/folder_open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/html.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/java.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/linux.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/music.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/pdf.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/php.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/picture.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/ppt.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/psd.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/ruby.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/script.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/spinner.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/txt.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/xls.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/images/zip.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/jqueryFileTree.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.filetree/jqueryFileTree.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.form-3.24.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.impromptu-3.2.min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.splitter/hgrabber.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.splitter/jquery.splitter-1.5.1.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.splitter/jquery.splitter.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.splitter/vgrabber.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/jquery.tablesorter-2.7.2.min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/cs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/da.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/de.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/en-gb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/es.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/fi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/fr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/he.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/hu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/it.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/ja.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/nl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/pl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/pt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/ru.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/sv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/tr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/vn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/zh-cn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/scripts/languages/zh-tw.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/styles/filemanager.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/styles/ie8.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/styles/ie9.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/styles/reset.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/userfiles/.htaccess'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/userfiles/web.config'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/userfiles/welcome.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/utils/generate-lang.py'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/filemanager/utils/minify.py'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/find/dialogs/find.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/flash/dialogs/flash.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/flash/images/placeholder.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/button.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/checkbox.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/form.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/hiddenfield.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/radio.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/select.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/textarea.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/dialogs/textfield.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/forms/images/hiddenfield.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/icons.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/icons_hidpi.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/iframe/dialogs/iframe.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/iframe/images/placeholder.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/image/dialogs/image.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/image/images/noimage.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/dialogs/anchor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/dialogs/link.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/images/anchor.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/link/images/hidpi/anchor.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/liststyle/dialogs/liststyle.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/magicline/images/hidpi/icon.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/magicline/images/icon.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/config.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/css/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/css/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/images/mediagallery.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/images/mediagallery.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/jscripts/functions.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/jscripts/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/langs/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/langs/english.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/langs/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/mediagallery.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/plugin.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/readme.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/templates/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/templates/mb.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/templates/mb_body.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/mediagallery/templates/mb_header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pagebreak/images/pagebreak.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/pastefromword/filter/default.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/placeholder/dialogs/placeholder.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/preview/preview.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt/dialogs/options.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt/dialogs/toolbar.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt/LICENSE.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/scayt/README.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_address.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_blockquote.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_div.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h1.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h3.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h4.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h5.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_h6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_p.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showblocks/images/block_pre.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showprotected/dialogs/protected.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/showprotected/images/code.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/dialogs/smiley.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/angel_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/angel_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/angry_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/angry_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/broken_heart.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/broken_heart.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/confused_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/confused_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/cry_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/cry_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/devil_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/devil_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/embaressed_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/embarrassed_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/embarrassed_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/envelope.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/envelope.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/heart.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/heart.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/kiss.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/kiss.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/lightbulb.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/lightbulb.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/omg_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/omg_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/regular_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/regular_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/sad_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/sad_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/shades_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/shades_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/teeth_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/teeth_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/thumbs_down.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/thumbs_down.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/thumbs_up.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/thumbs_up.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/tongue_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/tongue_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/tounge_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/whatchutalkingabout_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/whatchutalkingabout_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/wink_smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/smiley/images/wink_smile.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ar.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/bg.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/cs.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/cy.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/de.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/el.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/en-gb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/eo.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/es.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/et.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/fa.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/fi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/fr-ca.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/fr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/gl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/he.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/hr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/hu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/id.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/it.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ja.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/km.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ku.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/lv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/nb.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/nl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/no.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/pl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/pt-br.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/pt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ru.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/si.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/sk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/sl.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/sq.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/sv.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/th.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/tr.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/ug.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/uk.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/vi.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/zh-cn.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/zh.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/tt.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/lang/_translationstatus.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/specialchar/dialogs/specialchar.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/table/dialogs/table.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/tabletools/dialogs/tableCell.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/dialogs/templates.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/dialogs/templates.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates/default.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates/images/template1.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates/images/template2.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/templates/templates/images/template3.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/widget/images/handle.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/ciframe.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/tmp.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/tmpFrameset.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/wsc.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/wsc.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/dialogs/wsc_ie.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/LICENSE.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/wsc/README.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube/images/icon.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2/images/icon.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2/lang/en.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/plugins/youtube2/plugin.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/README.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog_ie.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog_ie7.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog_ie8.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog_iequirks.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/dialog_opera.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor_gecko.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor_ie.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor_ie7.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor_ie8.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/editor_iequirks.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/icons.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/icons_hidpi.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/arrow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/hidpi/close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/hidpi/lock-open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/hidpi/lock.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/hidpi/refresh.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/lock-open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/lock.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/images/refresh.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/skins/moono/readme.md'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/ckeditor/styles.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/comment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/css.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/directory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/ChangeLog'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/docstyle.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/calendar.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/captcha.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/config.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/filemgmt.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/forum.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/install.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/links.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/polls.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/spamx.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/staticpages.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/english/trackback.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/images/background.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/docs/license'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/brokenfile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/downloadhistory.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/arrow.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/counter.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/delete.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/down.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/download.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/filemgmt.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/filemgmt.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/home.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/newred.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/pop.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/screenshoticon.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/size.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/speck.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/up.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/images/update.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/ratefile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/singlefile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/submit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/viewcat.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt/visit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/category_snaps/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/category_snaps/tmp/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/files/css.pdf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/files/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/files/tmp/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/snaps/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/filemgmt_data/snaps/tmp/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/ajaxbookmark.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/ajaxdelfile.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/ajaxrate.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/bbcode.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/createtopic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/getattachment.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/gettopic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/alert_warning.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/asc.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/asc_on.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/badges/badge1.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/badges/badge2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/badges/forum_user.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/badges/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/badges/siteadmin_badge.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/busyforum.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/delete.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/desc.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/desc_on.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/document_sm.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/edit_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/email.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/email_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/forum.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/forumindex.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/gl_mootip_bg200.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/green_dot.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/home.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/ai.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/bmp.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/doc.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/exe.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/fic.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/gif.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/htm.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/jpg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/js.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/mdb.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/mov.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/mp3.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/mpp.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/none.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/pdf.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/php.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/png.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/ppt.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/psd.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/rar.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/swf.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/ttf.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/txt.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/vsd.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/xls.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icons/zip.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/icon_minipost.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/img_quote.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/latestposts.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/locked.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/locked_new.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/minus.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/angelic.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/angry.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/artistic.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/awake.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/blah.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/blank.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/brainy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/caffeinated.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/cheerful.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/cold.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/confused.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/curious.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/determined.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/dirty.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/dizzy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/embarrassed.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/envious.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/excited.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/flirty.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/freakingout.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/full.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/giggly.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/gloomy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/groggy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/grossedout.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/grumpy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/happy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/hopeful.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/hot.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/hungry.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/hungry2.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/hyper.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/indescribable.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/indifferent.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/lazy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/loved.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/magical.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/mellow.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/moody.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/musical.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/naughty.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/nerdy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/okay.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/rockin.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/sad.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/sick.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/silly.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/sleepy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/smart.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/sneezy.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/sore.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/spooky.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/stressed.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/stupid.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/surprised.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/thirsty.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/thoughtful.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/tired.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/unfocused.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/working.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/moods/worried.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/nav_breadcrumbs.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/nav_topic.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/newposts.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/noposts.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/notify_off.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/notify_on.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/padlock.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/pixel.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/plus.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/pm.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/pm_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/post_newtopic.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/post_reply.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/profile_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/quietforum.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/quote_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank0.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank1.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank2.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank3.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank4.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank_admin.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/ranks/rank_mod.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/red_dot.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/rss_small.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/arrow.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/biggrin.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/confused.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/cool.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/cry.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/eek.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/evil.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/exclaim.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/frown.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/idea.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/lol.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/mad.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/mrgreen.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/neutral.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/question.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/razz.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/redface.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/rolleyes.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/smile.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/surprised.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/twisted.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/smilies/wink.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/spacer.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/star_off_sm.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/star_on_sm.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/sticky.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/sticky_new.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/top.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/trash.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/images/website_button.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/ajax_bookmark.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/ajax_deletefile.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/ajax_rate.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/bbcode-signature.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/createtopic.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/javascript/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/list.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/media/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/media/tn/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/memberlist.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/moderation.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/notify.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/print.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/sigpreview.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/forum/viewtopic.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/getimage.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/advancedsearch.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/cceventsubmission.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/cclinksubmission.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/ccstorysubmission.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/ccusersubmission.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/submitevent.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/submitlink.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/help/submitstory.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/articles/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/datepicker.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/File/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Flash/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/cache.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotator1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotator2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotator3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotator4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotator5.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotatorblock1.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotatorblock2.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotatorblock3.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/moorotatorblock4.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/mootools.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/plugins.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/whatsnew.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Image/widgets.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/Media/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/library/userfiles/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/menu_bg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/menu_hover_bg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/menu_parent.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/moor_arrows.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/moor_boverlay.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/moor_cursor.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/moor_slider.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/moor_woverlay.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/menu/vmenu_parent.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/oauth-login-with-sprite.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/openid_login_icon.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/right_arrow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/speck.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/starrating.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/star_small.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/topics/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/topics/topic_gl.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/topics/topic_news.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/translations/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/translations/sprite-flags.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/userphotos/default.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/userphotos/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/images/working.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/bbcode.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/common.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/configmanager.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/fValidator.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moochronometer.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_mooie6warning.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moomenu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moopngfix.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_mooreflection.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moorotator-block.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moorotator.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moosimplebox.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_mooslide.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/gl_moospring.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/moorating.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/mootools/mootools-release-1.11.packed.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/moveusers.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/nogray_date_calendar_vs1_min.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/profile_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/pwd_strength.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/resetrating.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/javascript/sitetailor_ie6vertmenu.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/js.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/autotag/autotag.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/autotag/autotag_upload_confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/autotag/autotag_upload_form.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block/blockeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block/defaultblockeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/block/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/common/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/common/edit_permissions.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/common/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/configuration.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/config_element.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/config/menu_element.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/envcheck.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group/groupeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group/groupmembers.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/group/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/actionrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/field.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/listitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/searchmenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/lists/topmenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/logo/logo.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/mail/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/mail/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/mail/mailform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/clonemenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/createelement.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/createmenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/editelement.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/editmenu.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/menulist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/menu/menutree.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/ccitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/ccrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/moderation/moderation.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/plugin_upload_confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/plugin_upload_form.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/plugins/plugin_upload_old_confirm.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/story/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/story/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/story/storyeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication/feededitor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/syndication/selecttype.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/topic/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/topic/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/topic/topiceditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/autodetectitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/autodetectlist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pingbackform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pingbackitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pingbacklist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pingform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pingitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/pinglist.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/serviceeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/trackback/trackbackeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/accountpanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/adminuseredit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/batchadmin.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/batchadmin_options.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/contentpanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/edituser.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/groupedit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/grouppanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/layoutpanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/prefeditor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/privacypanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/subscriptionpanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/user/userinfopanel.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/admin/vercheck.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/adminoption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/adminoption_off.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/advanced_editor_header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/archivestorytext.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article/article.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/article/printable.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/bbcode/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/bbcode/editor.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-left.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-message.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-persistent-message.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-related.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter-right.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockfooter.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader-left.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader-list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader-message.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader-related.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader-right.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockheader.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/blockservices.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/ck_styles.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/comment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/commentbar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/commentform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/notifymessage_html.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/notifymessage_text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/reportcomment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/startcomment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/comment/thread.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/digest.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/digest_story.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/digest_story_text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/digest_text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/errormessage.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/featuredstorytext.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/footer.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/functions.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/header.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/htmlheader.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/ie6.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/ie7.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/addchild.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/accept.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/action.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/add.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/addchild.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/ascending.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/blank.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/block-left.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/block-right.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/check.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/copy.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/cross.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/delete.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/descending.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/disk.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/edit.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/greycheck.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/greyinfo.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/greyuser.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/group.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/info.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/list.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/mail.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/update.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/user.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/admin/wrench.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/alert-small.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/alert.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/arrow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/arrow_down.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/arrow_open.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bar.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bararrowdown.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bararrowup.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bg_search.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/blank.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bottom-l-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bottom-r-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bug.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bullet-blue.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bullet-grey.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bullet-plus.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bullet-rss.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/bullet-star.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/button_help.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/cart.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/check.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/cms-glfusion.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/cms-glfusion.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/code.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/collapse.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/copy.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/delete.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/deleteitem.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/disc.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/down.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/download.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/edit.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/expand.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/favicon.ico'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gear.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gl_moomenu1-parent_ie6.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gl_mooticker_controls.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gl_mooticker_controls_ie6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gl_mootip_bg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/gl_mootip_bg200.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/grabit.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg-afternoon.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg-dawn.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg-day.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg-dusk.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg-night.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/header-bg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/headphones.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/help.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/home.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/autotag.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/block.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/configuration.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/ctl.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/database.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/docs.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/envcheck.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/event.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/filecheck.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/group.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/logo.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/logout.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/logview.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/mail.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/menubuilder.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/moderation.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/plugins.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/sfs.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/story.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/syndication.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/topic.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/trackback.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/user.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/icons/versioncheck.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/idea.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/ie6_close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/ie6_warning.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/info.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/joinus.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/list.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/location.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/lock.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/mail.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/mic.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/moosimplebox/bg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/moosimplebox/close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/moosimplebox/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/next.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/next_ie6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/note.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-1.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-1g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-2.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-2g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-3.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-3g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-4.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-4g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-5.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-5g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-6g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-7.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-7g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-8.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-8g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-9.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/number-9g.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/online.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/pgpkey.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/prev.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/prev_ie6.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/print.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/quote-l.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/quote-r.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/rainbow.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/readit.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/rss.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/rss_small.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/sayit.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/script.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/search.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/sendping.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/smallcamera.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/speaker.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/speck.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/sysmessage.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/tools.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/top-l-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/top-r-corner.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/up.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/images/video.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/js/currentpage.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/js/gltips.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/js/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/leftblocks.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/listitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/item_field.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/item_row.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/page_limit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/inline/page_sort.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/item_field.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/item_row.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/list.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/page_limit.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/lists/table/page_sort.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/loginform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/loginform_oauth.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/loginform_openid.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/logo-graphic.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/logo-text.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/animate.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/menu_horizontal_cascading.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/menu_horizontal_simple.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/menu_vertical_cascading.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menu/menu_vertical_simple.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menuitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menuitem_last.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/menuitem_none.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/breadcrumbs.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/breadcrumb_link.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images/tableftI.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images/tableftJ.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images/tabrightI.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/images/tabrightJ.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/menuitem.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/navbar/navbar.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/nouveau.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/boxesblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/commentblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/current_password.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/deleteaccount.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/digestblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/displayblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/displayprefs.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/excludeblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/language.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/password.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/privacyblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/profile.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/resynch.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/subscriptionblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/theme.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/username.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/preferences/userphoto.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles/contactauthorform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles/contactuserform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/profiles/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/README'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/rightblocks.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/headingcolumn.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resultauthdatehits.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resultcolumn.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resultrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resultrowenhanced.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resultsummary.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/resulttitle.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchauthors.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchblock.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchresults.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchresults_heading.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchresults_norows.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/search/searchresults_rows.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/itemstatistics.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/singlestat.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/singlesummary.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/stats/sitestatistics.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/storytext.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/style-colors.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit/submitloginrequired.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/submit/submitstory.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/sysmessage.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/theme.ini'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/tn_nouveau.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/topcenterblock-span.thtmlx'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/topicoption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/topicoption_off.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/formattedcomment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/trackback.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/trackback/trackbackcomment.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/useroption.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/useroption_off.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/commentrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/custom/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/email.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/getpasswordform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/loginform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/mergeacct.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/newpassword.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/newtoken.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/profile.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/reauthform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/registrationform.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/services.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/layout/nouveau/users/storyrow.thtml'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/lib-common.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/links/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/links/images/links.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/links/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/links/portal.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/admin.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/album.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/album_rpc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/batch.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/download.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/enroll.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/BBL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/BBR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/LLB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/LLT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/RRB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/RRT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/TTL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/bamboo/TTR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/book/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/BB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/BBL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/BBR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/BL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/BR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/LL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/LLB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/LLT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/RR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/RRB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/RRT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/TL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/TR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/TT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/TTL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/brand/TTR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/diapo/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/dotapple/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/flicking/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/BB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/BBL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/BBR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/BL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/BR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/LL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/LLB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/LLT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/RR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/RRB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/RRT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/TL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/TR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/TT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/TTL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/gold2/TTR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/BC.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/BL.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/BR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/halo.psd'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/LC.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/RC.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/TC.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/TL.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/halo/TR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/BBL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/BBR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/TTL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/kodak/TTR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/pixel_trans.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legored/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/pixel_trans.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoredsmall/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/pixel_trans.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellow/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/pixel_trans.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/legoyellowsmall/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/notebook/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroid/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/polaroids/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/BB5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/BL5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/BR5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/LL5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/ReadMe.txt'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/RR5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/TL5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/TR5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/postage_due/TT5.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbook/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/BBL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/BBR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/LLB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/LLT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/RRB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/RRT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/TTL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/scrapbookshadowsmall/TTR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/BB.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/BBL.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/BR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/RR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow/RRT.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/BB.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/BBL.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/BR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/RR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_light/RRT.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/BB.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/BBL.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/BR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/RR.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shadow_lighter/RRT.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/BB.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/BL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/BR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/LL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/RR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/TL.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/TR.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/shell/TT.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/slide/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/BB.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/BL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/BR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/frame.inc'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/LL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/RR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/TL.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/TR.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/frames/traintrack/TT.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/fslideshow.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/gallery_remote2.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/getcard.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/html5upload.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/1_close.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/1_loading.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/1_next.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/1_prev.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/arrow-left.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/arrow-right.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/blank_blk.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/button_help.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/closelabel.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/digibug.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/feed.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/icon_envelopeSmall.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/icon_small_envelope.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/loading.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/mediagallery.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/mediagallery.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/nextlabel.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/powerby_mg-REVERSED.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/powerby_mg.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/powerby_mg.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/prevlabel.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/progress_bar.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/progress_bar_full.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/rotate_left_icon.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/rotate_right_icon.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/shutterfly.jpeg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/stamp.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/starrating.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/star_small.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/star_small.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/SWFUploadButton.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/images/working.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/admin_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/avdefaults_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/client_sniff.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/defaults_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/mediagallery.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/memberalbums_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/qtobject.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/slideshow.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/slimbox.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/js/swfobject.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/lightbox.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mad.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/media.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/audio.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/covers/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/0/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/1/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/2/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/3/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/4/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/5/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/6/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/7/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/8/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/9/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/a/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/b/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/c/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/d/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/e/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/f/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/disp/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/empty.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/flash.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/flv.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/generic.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/googlevideo.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/mediagallery.gif'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/missing.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/0/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/1/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/2/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/3/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/4/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/5/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/6/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/7/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/8/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/9/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/a/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/b/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/c/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/d/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/e/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/f/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/orig/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/pdf.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/quicktime.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/remote.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/0/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/1/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/2/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/3/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/4/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/5/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/6/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/7/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/8/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/9/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/a/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/b/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/c/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/d/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/e/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/f/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/tn/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/video.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/wmp.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/youtube.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mediaobjects/zip.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/media_popup.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mgcss.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/mgjs.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/phpinfo.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/playall.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/audio-player.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/expressinstall.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/FlowPlayer.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/FMP3.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/MGflv.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/MGmp3.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/minislideshow.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/play.jpg'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/player.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/slideshow.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/sviewer.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/XSPF_EV.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/players/XSPF_RadioV.swf'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/popup.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/postcard.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/property.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/search.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/simpleviewer.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/slideshow.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/subscription.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/thumbnail.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/userprefs.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/video.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/watermarks/blank.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/watermarks/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/xml.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/mediagallery/xspf.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/page.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/pgp.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/pingback.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/polls/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/polls/images/polls.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/polls/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/polls/polls_editor.js'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/polls/style.css'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/privpol.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/profiles.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/rater.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/rater_rpc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/revalidate.inc.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/robots.txt.sample'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/search.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/siteconfig.php.dist'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/sitedown.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/staticpages/images/delete.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/staticpages/images/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/staticpages/images/staticpages.png'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/staticpages/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/stats.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/submit.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/switchlang.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/terms.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/trackback.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/users.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/usersettings.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/webservices/atom/index.php'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'public_html/webservices/index.html'),
    array( 'test' => 'E', 'preq' => 'R', 'path' => 'README')
);
?>